﻿package 
{
	import adobe.utils.CustomActions;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
        import flash.text.TextField;
	import flash.utils.*;
	/**
	 * ...
	 * @author CSK
         * http://www.csksoft.net
	 */
	public class Main extends Sprite 
	{
		// array for recording benchmark data
		static public var perfData_interpret:Array = new Array();
		static public var perfData_jit:Array = new Array();
		static public var perfData_jit2:Array = new Array();
		// trace info buffer
		static public var output:String = "";
		
		// The Text field to show the trace info
		public var text:TextField;
		
				
        static private var loopcnt:uint = 0;
        static private var start_time:int, start_time2:int,end_time:int;
        static private var unsigned:uint, real:Number, integer:int;
        
		// {
		// This actual is the Main$cinit block
		// The AVM will execute it using interpret only, but any function call will use JIT as well
		// put all the benchmark code here, force interperting it
		trace_out("Begin $cinit section");
		
        start_time2 = getTimer();
		for (  ; loopcnt < 100; loopcnt++)
		{
			start_time = getTimer();
			unsigned = 0;
				while (unsigned++ < 1000)
				{
					integer = unsigned * unsigned;
					real /= integer;
				}
			end_time = getTimer();
			addBenchData( end_time - start_time, perfData_interpret);
		}
		
		trace_out("End $cinit section, total time used: " + (getTimer() - start_time2)+" ms");
		// }
		
        public function jit_test1():void
        {
            unsigned = 0;
			// The same code piece  the one in $cinit, JIT will be applied
				while (unsigned++ < 1000)
				{
					integer = unsigned * unsigned;
                    real = Math.exp(unsigned);
					real /= integer;
				}
        }
		
///////////////////////////////////////////////////////////////////////////////
		public function Main():void 
		{
			trace_out("Begin Ctor section");
            start_time2 = getTimer();
            for ( loopcnt=0 ; loopcnt < 100; loopcnt++)
			{
				start_time= getTimer();
                jit_test1();
                end_time = getTimer();
                addBenchData( end_time - start_time, perfData_jit);
            }
			trace_out("End Ctor section, total time used: " + (getTimer() - start_time2) + " ms");
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
			
			setTimeout( DelayedPerf, 1000);
			
		}
        
        public function DelayedPerf():void
        {
                trace_out("Begin JITPerf loop");
				jitloop(20);
				trace_out("End JITPerf section\n");
			
                drawPerfGraph();
				text.htmlText = output;
        }
		
		private function drawPerfGraph():void
		{
            function getMax(arr:Array):int
            {
                var pos:int, len:int;
                var maxval:int = 0;
                len = arr.length;
                for (pos = 0; pos < len; pos++)
                {
                    if (maxval < arr[pos]) maxval = arr[pos];
                    
                }
                return maxval;
            }
       
			// 
			var chart_mc:Sprite = new Sprite;
            stage.addChild(chart_mc);
            
            
            // pre-parse to get the max value
            var maxvalue:int = Math.max(getMax(perfData_interpret), getMax(perfData_jit));
            var scalefactor_Y:Number = (300 / Number(maxvalue));
            var scalefactor_X:Number = 500 / Number(perfData_interpret.length);
            var common_len:int = perfData_interpret.length;
            // draw the interp line
            chart_mc.graphics.lineStyle(1, 0xFF);
            chart_mc.graphics.moveTo( 300, 300 - perfData_interpret[0] * scalefactor_Y);
            
            
            for (loopcnt = 1; loopcnt < common_len; loopcnt++)
            {
                chart_mc.graphics.lineTo( 300 + loopcnt*scalefactor_X, 300 - perfData_interpret[loopcnt] * scalefactor_Y);
            }
            
            // draw the transalted-perf line
            chart_mc.graphics.lineStyle(1, 0xFF0000);
            chart_mc.graphics.moveTo( 300, 300 - perfData_jit[0] * scalefactor_Y);
 
            
            for (loopcnt = 1; loopcnt < common_len; loopcnt++)
            {
                chart_mc.graphics.lineTo( 300 + loopcnt*scalefactor_X, 300 - perfData_jit[loopcnt] * scalefactor_Y);
            }       
            
            // draw Label
            var lblInterpret:TextField = new TextField();
            stage.addChild(lblInterpret);
            lblInterpret.x = 300  - 100;
            lblInterpret.y = 300 - perfData_interpret[0] * scalefactor_Y;
            lblInterpret.textColor = 0xFF;
            lblInterpret.text = "Main$cint(Interpret)";
            
            var lblCtor:TextField = new TextField();
            stage.addChild(lblCtor);
            lblCtor.x = 300 - 100;
            lblCtor.y = 300 - perfData_jit[0] * scalefactor_Y;
            lblCtor.textColor = 0xFF0000;
            lblCtor.text = "Main.ctor()(JIT)";
            
            // draw the JIT line
            maxvalue = getMax(perfData_jit2);
            scalefactor_Y = (300 / Number(maxvalue));
            scalefactor_X = 500 / Number(perfData_jit2.length);
            common_len = perfData_jit2.length;
            chart_mc.graphics.lineStyle(1, 0xFF00);
            chart_mc.graphics.moveTo( 300, 700 - perfData_jit2[0] * scalefactor_Y);

            
            for (loopcnt = 1; loopcnt < common_len; loopcnt++)
            {
                chart_mc.graphics.lineTo( 300 + loopcnt*scalefactor_X, 700 - perfData_jit2[loopcnt] * scalefactor_Y);
            }        
            
            
            // draw Label

            var lblJIT:TextField = new TextField();
            stage.addChild(lblJIT);
            lblJIT.x = 300 - 100;
            lblJIT.y = 700 - perfData_jit2[0] * scalefactor_Y;
            lblJIT.textColor = 0xFF00;
            lblJIT.text = "JITPerf(JIT)";
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
            
            text = new TextField();
            text.text = "please wait...";
            stage.addChild(text);
			text.width = 300;
			text.height = 600;
			
		}
		
        private function simple_performance_test ():void
        {
            // CSE testing & deadcode removal
            var n:int = 10;
            
            var b:int = n + 10000;
            var c:int = n + 10000;
            
            var e:Number = n + 10000;
            
            n++;
            n = n + 1;
            
            n = uint(n + 1);
            
            // CSE 2
            var myArray:Array = ["a", "b", "c"];
            for (n = 0; n < myArray.length; n++ )
            {
                // do nothing
            }
            
            b = myArray.length
            for (n = 0; n < b; n++ )
            {
                var tmp:String = myArray[n];
                tmp = myArray[uint(n)];
            }
        }
		
		public function jitloop(looptime:uint):void
		{
			var n:uint = 0;
			do {
                start_time= getTimer();
				jit_test();  
                end_time = getTimer();
                addBenchData( end_time - start_time, perfData_jit2);
			}
			while (++n<looptime);
		}
		
		public function jit_test():Array
		{
			trace_out("------------------------------------------");
			//Create the source array
			var list:Array = new Array();
			var myNumber:Number = 2;
			for(var i:int = 0; i < 500000; i++)
			{
				list.push(Math.random()*500000);
			}
			trace_out("List of " + list.length + " elements.");
			
			//TEST-1 Barebones for loop, unoptimized.

			var t1s:Number = getTimer();
			var copy:Array = new Array();
			for(var j:int = 0; j < list.length; j++)
			{
				copy.push( list[i] );
		
			}
			var t1e:Number = getTimer();
			trace_out("for() unoptimized: "+(t1e-t1s)+"ms");


			/***********/


			//TEST-2 Barebones for loop, optimized.

			var t2s:Number = getTimer();
			var copy2:Array = new Array();
			var l2:int = list.length;
			for(var m:int = 0; m < l2; ++m)
			{
				copy2[m] = list[m];
				
			}
			var t2e:Number = getTimer();
			trace_out("for() key-key optimized: " + (t2e-t2s) + "ms");
			
			
			//TEST-3 Pure operation

			var t3s:Number = getTimer();
			
			append_concat(5000);
			var t3e:Number = getTimer();
			trace_out("for() Pure operation: " + (t3e-t3s) + "ms");	
			
			//TEST-4 FFT operation
			var t4s:Number = getTimer();
			
			fft_bench();
			var t4e:Number = getTimer();
			trace_out("for() FFT operation: " + (t4e-t4s) + "ms");	

			return list;
		}
		
		
		
		
		public function fft_bench():void
		{
			var myFFT:FFT = new FFT();
			// main
			
			var starttime:Number=new Date();
			var cycles:int = 50;
			

			var R:Random = new Random(Constants.RANDOM_SEED, 0, 1);
			var N:int = Constants.FFT_SIZE;
			var x:Array = FFT.RandomVector(2*N, R);
			for (var i:uint=0; i<cycles; i++){
				FFT.transform(x); // forward transform
				FFT.inverse(x); // backward transform
			}
			
			
		}
		
		
		public function append_concat(loops:uint):void {
			var x:String = '';
			for (var i:uint=0; i<loops; i++) {
				x = x.concat('abcdefghijklmnopqrstuvwxyz0123456789');
			}
		}
		
		static public function addBenchData( val:int, arr:Array):void
		{
			arr.push(val);
		}
	
		static public function trace_out( str:String):void
		{
			
			output += str + "\n";
		}
	}
	
}
