/*
 *   Demo application for AVM2 extension
 *   By Shikai Chen
 *   http://www.csksoft.net
 *
 */
package FMOD_DEMO
{
    import avmplus.*;
    import C.unistd.*;
    import _csk_extension_.*;
    
    class Main
    {
        public function PlaySnd_n_Rendering():void
        {
            var handle:int;
            
            FMUSIC_ini();
            
            handle = FMUSIC_LoadSong("heaven7.xm");
            
            if (handle == 0) {
                print("Cannot play the sound");
                return;
            }
            
            FMUSIC_PlaySong(handle);
            
            createGLWindow(600,600,16,false);
            
            while (1) {
                var ord:int , row:int, time:int;
                ord = FMUSIC_GetOrder(handle);
                row = FMUSIC_GetRow(handle);
                time = FMUSIC_GetTime(handle);
                render_gl();
                usleep(2);
                print( "ord: " + ord + " row: " + row + " sec: " + (time/1000)); 
            }
            
            
        }
        
        public const GL_COLOR_BUFFER_BIT:uint = 	0x00004000;
        public const GL_DEPTH_BUFFER_BIT:uint =     0x00000100;
        public const GL_TRIANGLES:uint = 	0x0004;
        public const GL_QUADS:uint = 	0x0007;
        
        
        public static var rtri:Number = 0;
        public static var rquad:Number = 0;
        public function render_gl():void {
            glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
            glLoadIdentity();									// Reset The Current Modelview Matrix
            glTranslatef(-1.5,0.0,-6.0);						// Move Left 1.5 Units And Into The Screen 6.0
            glRotatef(rtri,0.0,1.0,0.0);						// Rotate The Triangle On The Y axis ( NEW )
            glBegin(GL_TRIANGLES);								// Start Drawing A Triangle
                glColor3f(1.0,0.0,0.0);						// Red
                glVertex3f( 0.0, 1.0, 0.0);					// Top Of Triangle (Front)
                glColor3f(0.0,1.0,0.0);						// Green
                glVertex3f(-1.0,-1.0, 1.0);					// Left Of Triangle (Front)
                glColor3f(0.0,0.0,1.0);						// Blue
                glVertex3f( 1.0,-1.0, 1.0);					// Right Of Triangle (Front)
                glColor3f(1.0,0.0,0.0);						// Red
                glVertex3f( 0.0, 1.0, 0.0);					// Top Of Triangle (Right)
                glColor3f(0.0,0.0,1.0);						// Blue
                glVertex3f( 1.0,-1.0, 1.0);					// Left Of Triangle (Right)
                glColor3f(0.0,1.0,0.0);						// Green
                glVertex3f( 1.0,-1.0, -1.0);					// Right Of Triangle (Right)
                glColor3f(1.0,0.0,0.0);						// Red
                glVertex3f( 0.0, 1.0, 0.0);					// Top Of Triangle (Back)
                glColor3f(0.0,1.0,0.0);						// Green
                glVertex3f( 1.0,-1.0, -1.0);					// Left Of Triangle (Back)
                glColor3f(0.0,0.0,1.0);						// Blue
                glVertex3f(-1.0,-1.0, -1.0);					// Right Of Triangle (Back)
                glColor3f(1.0,0.0,0.0);						// Red
                glVertex3f( 0.0, 1.0, 0.0);					// Top Of Triangle (Left)
                glColor3f(0.0,0.0,1.0);						// Blue
                glVertex3f(-1.0,-1.0,-1.0);					// Left Of Triangle (Left)
                glColor3f(0.0,1.0,0.0);						// Green
                glVertex3f(-1.0,-1.0, 1.0);					// Right Of Triangle (Left)
            glEnd();											// Done Drawing The Pyramid

            glLoadIdentity();									// Reset The Current Modelview Matrix
            glTranslatef(1.5,0.0,-7.0);						// Move Right 1.5 Units And Into The Screen 7.0
            glRotatef(rquad,1.0,1.0,1.0);					// Rotate The Quad On The X axis ( NEW )
            glBegin(GL_QUADS);									// Draw A Quad
                glColor3f(0.0,1.0,0.0);						// Set The Color To Green
                glVertex3f( 1.0, 1.0,-1.0);					// Top Right Of The Quad (Top)
                glVertex3f(-1.0, 1.0,-1.0);					// Top Left Of The Quad (Top)
                glVertex3f(-1.0, 1.0, 1.0);					// Bottom Left Of The Quad (Top)
                glVertex3f( 1.0, 1.0, 1.0);					// Bottom Right Of The Quad (Top)
                glColor3f(1.0,0.5,0.0);						// Set The Color To Orange
                glVertex3f( 1.0,-1.0, 1.0);					// Top Right Of The Quad (Bottom)
                glVertex3f(-1.0,-1.0, 1.0);					// Top Left Of The Quad (Bottom)
                glVertex3f(-1.0,-1.0,-1.0);					// Bottom Left Of The Quad (Bottom)
                glVertex3f( 1.0,-1.0,-1.0);					// Bottom Right Of The Quad (Bottom)
                glColor3f(1.0,0.0,0.0);						// Set The Color To Red
                glVertex3f( 1.0, 1.0, 1.0);					// Top Right Of The Quad (Front)
                glVertex3f(-1.0, 1.0, 1.0);					// Top Left Of The Quad (Front)
                glVertex3f(-1.0,-1.0, 1.0);					// Bottom Left Of The Quad (Front)
                glVertex3f( 1.0,-1.0, 1.0);					// Bottom Right Of The Quad (Front)
                glColor3f(1.0,1.0,0.0);						// Set The Color To Yellow
                glVertex3f( 1.0,-1.0,-1.0);					// Top Right Of The Quad (Back)
                glVertex3f(-1.0,-1.0,-1.0);					// Top Left Of The Quad (Back)
                glVertex3f(-1.0, 1.0,-1.0);					// Bottom Left Of The Quad (Back)
                glVertex3f( 1.0, 1.0,-1.0);					// Bottom Right Of The Quad (Back)
                glColor3f(0.0,0.0,1.0);						// Set The Color To Blue
                glVertex3f(-1.0, 1.0, 1.0);					// Top Right Of The Quad (Left)
                glVertex3f(-1.0, 1.0,-1.0);					// Top Left Of The Quad (Left)
                glVertex3f(-1.0,-1.0,-1.0);					// Bottom Left Of The Quad (Left)
                glVertex3f(-1.0,-1.0, 1.0);					// Bottom Right Of The Quad (Left)
                glColor3f(1.0,0.0,1.0);						// Set The Color To Violet
                glVertex3f( 1.0, 1.0,-1.0);					// Top Right Of The Quad (Right)
                glVertex3f( 1.0, 1.0, 1.0);					// Top Left Of The Quad (Right)
                glVertex3f( 1.0,-1.0, 1.0);					// Bottom Left Of The Quad (Right)
                glVertex3f( 1.0,-1.0,-1.0);					// Bottom Right Of The Quad (Right)
            glEnd();											// Done Drawing The Quad

            glRender();
            rtri+=0.4;											// Increase The Rotation Variable For The Triangle ( NEW )
            rquad-=0.3;	
        }
        
        public function Main():void {
            PlaySnd_n_Rendering();
        }
       
        new Main();
    }
}
